require "htauth/md5"

module RailsSvnAdmin
  module Htpasswd

    def self.decode(entry)
      result = {}
      temp = entry.chomp.chomp.chomp.chomp.split(":")
      if temp.size == 2
        result[:user] = temp[0]
        temp = temp[1].split("$")
        if temp.size == 4
          result[:magic] = temp[1]
          result[:salt] = temp[2]
          result[:md5] = temp[3]
        end
      end
      result
    end

    def self.encode(user)
      "#{user[:user]}:$#{user[:magic]}$#{user[:salt]}$#{user[:md5]}"
    end

    def self.md5(password, salt)
      htauth_md5 = HTAuth::Md5.new(:salt => salt)
      htauth_md5.encode(password).gsub(/\n/, "").split("$").compact[3]
    end

    def self.htpasswd(user, password)
      result = `htpasswd -nbm #{user} #{password}`
      self.decode(result)
    end

  end
end
